<?php
/*
Plugin Name: Horoscop
Plugin URI: http://wordpress.org/extend/plugins/horoscop/
Description: Horoscop este un plugin creat pentru afişarea celor 12 zodii într-un widget pe oricare dintre sidebarurile blogului pe care este poziţionat. Se activează pluginul, apoi se poziţionează widgetul numit "Horoscop" în sidebarul dorit. <strong>Pluginul solicită ca modulul PHP "allow_url_fopen" să fie activat</strong>.
Version: 1.4.5
Author: Vlădut Ilie
Author URI: http://vladilie.ro/
License: GPL2
*/
/*  Copyright 2013  Vlădut Ilie  (email: vladilie94@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
if ( !function_exists( 'add_action' ) ) exit( 'Salut! Ce mai faci?<br/>Ceea ce cauti nu este aici, nu? Ma gandeam eu :)' );
$signs = array( 'berbec', 'taur', 'gemeni', 'rac', 'leu', 'fecioara', 'balanta', 'scorpion', 'sagetator', 'capricorn', 'varsator', 'pesti' );
class Horoscop extends WP_Widget {
    public function __construct() {
        parent::__construct(
            'Horoscop', // Base ID
            'Horoscop', // Name
             array( 'description' => __( 'Afiseaza cele 12 zodii in sidebar.' ), ) // Args
	    );
    }
    public function widget( $args, $instance ) {
        extract( $args );
        $title = apply_filters( 'widget_title', $instance['title'] );
        echo $before_widget;
        if ( ! empty( $title ) )
            echo $before_title.$title.$after_title;
        $code = '<script language="javascript" type="text/javascript">
        function pop_up( url )
        {
            newwindow = window.open( url,"'.$instance['title'].'", "height=230,width=500" );
            if ( window.focus )
            {
                newwindow.focus();
            }
            return false;
        }</script>';
        $code .= '<ul>';
        global $signs;
        foreach ( $signs AS $sign )
        {
            $code .= "<li><a href=\"horoscop/".$sign."\" title=\"".$sign."\" onclick=\"return pop_up('horoscop/".$sign."')\">".ucfirst( $sign )."</a></li>";
        }
        $code .= '</ul>';
        echo $code;
	echo $after_widget;
    }
    public function update( $new_instance, $old_instance ) {
        $instance = array();
        $instance['title'] = strip_tags( $new_instance['title'] );
        return $instance;
    }
    public function form( $instance )
    {
        if ( isset( $instance['title'] ) ) {
            $title = $instance['title'];
        } else {
            $title = __( 'Horoscop' );
        }
        ?>
        <p>
        <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Titlu:' ); ?></label>
        <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>"/>
        </p>
        <?php
    }
}
add_action( 'widgets_init', create_function( '', 'register_widget( "Horoscop" );' ) );

function clean_rewrites()
{
    global $wp_rewrite;
    $wp_rewrite->flush_rules();
}
function add_rewrites()
{
    global $wp_rewrite;
    $rules = array( 'horoscop/([^/\.]+)/?$' => 'wp-content/plugins/horoscop/horoscop.php?zodie=$1' );
    $wp_rewrite->non_wp_rules = $rules + $wp_rewrite->non_wp_rules;
}
add_action( 'generate_rewrite_rules', 'add_rewrites' );
add_action( 'admin_init', 'clean_rewrites' );

/*
    @function: auto_deactivate(), cleanup_horoscop()
    @since: 1.4.5
*/
function auto_deactivate() {
    $plugin = plugin_basename( __FILE__ );
    if ( is_plugin_active( $plugin ) && !ini_get( 'allow_url_fopen' ) ) {
        deactivate_plugins( $plugin );
        echo '<div class="error"><p>'.__('Din pacate pluginul <b>Horoscop</b> nu a fost activat.<br/>
Modulul PHP "allow_url_fopen" nu este functional si din aceasta cauza, pluginul nu poate fi folosit. Eventual, contactati firma dumneavoastra de hosting in legatura cu aceasta problema.').'</p></div>';
        unset( $_GET['activate'] );
    }
}
add_action( 'admin_init', 'auto_deactivate' );

function cleanup_horoscop() {
    delete_option( 'widget_horoscop' );
    flush_rewrite_rules();
}
register_deactivation_hook( __FILE__, 'cleanup_horoscop' );
?>
